//Initialisation for the velocity field and partial distribution functions
void zacPriblUF(long seed){
  int l,m;
  float perturbacija;
  ran2(&seed);
  for(l=0;l<NMAX;l++){   
      float x,y,z, dirX, dirY, dirZ;
  
      x=(float)(i_vr(l))+(float)(I)/2;
      y=(float)(j_vr(l))+(float)(J)/2;
      z=(float)(k_vr(l))-4;
  
      dirX=0;//.01*x/sqrt(x*x+y*y+z*z);
      dirY=0;//.01*y/sqrt(x*x+y*y+z*z);
      dirZ=0;//.01*z/sqrt(x*x+y*y+z*z);
    U[1][l]=0;//.1*ran2(&seed);//05f*( J*J/4-(j_vr(l)-J/2)*(j_vr(l)-J/2))/J/J;//ran2(&seed);
    U[2][l]=0;//.1*ran2(&seed);//0.005f*ran2(&seed);
    U[3][l]=0;//.1*ran2(&seed);
    U[4][l]=DENSITYINIT;
  }
    
   izrFeq(FEQ);
   #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500) private(m)
   for(l=0;l<NMAX;l++){
    for(m=0;m<ST_HITROSTI;m++){F[m][l]=FEQ[m][l]; FNEW[m][l]=F[m][l]; }
   }
}


//Computes velocity field from F
void calcF2Ul(int l, float **f){
  int m;
  float fex=0.f, fey=0.f, fez=0.f, density=0.f;
  
  if(LMARK[l]==LMARK1){
    for(m=0;m<ST_HITROSTI;m++){
      density+=f[m][l];
      fex+=f[m][l]*E[m][1];
      fey+=f[m][l]*E[m][2];
      fez+=f[m][l]*E[m][3];
    }
    float faktor=0.5f;	//Correction due to discrete lattice effects
    fex+=faktor*FORCE[1][l];
    fey+=faktor*FORCE[2][l];
    fez+=faktor*FORCE[3][l];
    
    U[1][l]=fex/density;
    U[2][l]=fey/density;
    U[3][l]=fez/density;
    U[4][l]=density;
//     printf("%d ",LMARK[l]);

  }
 else{ U[4][l]=DENSITYINIT; U[1][l]=UNIC[1][l]; U[2][l]=UNIC[2][l]; U[3][l]=UNIC[3][l];}
}


void calcFNEW2F(){
  int l;
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500)
  for(int l=0; l<NMAX; l++){
    if(LMARK[l]==LMARK1) for(int m=0; m<ST_HITROSTI; m++) F[m][l]=FNEW[m][l];
 }
}


//Fills in local molecular field from the global matrix
void fillHl(int l,float (*h)[4])
{
	h[1][1]=H[1][l];
	h[2][2]=H[2][l];
	h[3][3]=H[3][l];
	h[1][2]=H[4][l];
	h[1][3]=H[5][l];
	h[2][3]=H[6][l];
	h[2][1]=h[1][2];
	h[3][1]=h[1][3];
	h[3][2]=h[2][3];
}

void compute_stress_tensor(){
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500)
  for(int l=0;l<NMAX;l++){
    if(!(LMARK[l]==LMARK1)) continue;
    float trQH;
    float hl[4][4],qlm[4][4];
    float qlm_hl[4][4];
  //   float hl_qlm[4][4];

    fillHl(l,hl);					//fill the local molecular field matrix
    fillQlm2(l,qlm);				//fill the local order parameter tensor matrix

    AMatrixB(qlm_hl,qlm,hl);		//Matrix multiplication
  //   AMatrixB(hl_qlm,hl,qlm);
    
    trQH=qlm_hl[1][1]+qlm_hl[2][2]+qlm_hl[3][3];
    
    float tau_sim12=(-XI*(qlm_hl[2][1]+qlm_hl[1][2]+2.f/3.f*hl[1][2])+2.f*XI*(qlm[1][2])*trQH );
    float tau_asim12=qlm_hl[1][2]-qlm_hl[2][1];
    float tau_sim13=(-XI*(qlm_hl[3][1]+qlm_hl[1][3]+2.f/3.f*hl[1][3])+2.f*XI*(qlm[1][3])*trQH );
    float tau_asim13=qlm_hl[1][3]-qlm_hl[3][1];
    float tau_sim23=(-XI*(qlm_hl[3][2]+qlm_hl[2][3]+2.f/3.f*hl[2][3])+2.f*XI*(qlm[2][3])*trQH );
    float tau_asim23=qlm_hl[2][3]-qlm_hl[3][2];


    TAU[1][l]=(-XI*(2*qlm_hl[1][1]+2.f/3.f*hl[1][1])+2.f*XI*(qlm[1][1]+1/3.f)*trQH ) -ZETA*qlm[1][1];				//calculate local stress tensor
    TAU[2][l]=(-XI*(2*qlm_hl[2][2]+2.f/3.f*hl[2][2])+2.f*XI*(qlm[2][2]+1/3.f)*trQH ) -ZETA*qlm[2][2];
    TAU[3][l]=(-XI*(2*qlm_hl[3][3]+2.f/3.f*hl[3][3])+2.f*XI*(qlm[3][3]+1/3.f)*trQH ) -ZETA*qlm[3][3];
    TAU[4][l]=tau_asim12+tau_sim12 -ZETA*qlm[1][2];
    TAU[5][l]=tau_asim13+tau_sim13 -ZETA*qlm[1][3];
    TAU[6][l]=tau_asim23+tau_sim23 -ZETA*qlm[2][3];
    TAU[7][l]=-tau_asim12+tau_sim12 -ZETA*qlm[2][1];
    TAU[8][l]=-tau_asim13+tau_sim13 -ZETA*qlm[3][1];
    TAU[9][l]=-tau_asim23+tau_sim23 -ZETA*qlm[3][2];
  }
  
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500)
  for(int l=0; l<NMAX; l++){
    int lpbc=calcLpbc(l);
    if(lpbc!=l) for(int m=1; m<=9; m++) TAU[m][l]=TAU[m][lpbc];
  }
}

//Funkcija, ki izracuna stress tenzor v dani tocki
// void izrAStressL(int l,float (*tau)[4]){
//   float trQH;
//   float hl[4][4],qlm[4][4];
//   float qlm_hl[4][4];
//   float hl_qlm[4][4];
// 
//   fillHl(l,hl);					//fill the local molecular field matrix
//   fillQlm2(l,qlm);				//fill the local order parameter tensor matrix
// 
//   AMatrixB(qlm_hl,qlm,hl);		//Matrix multiplication
//   AMatrixB(hl_qlm,hl,qlm);
//   
//   trQH=qlm_hl[1][1]+qlm_hl[2][2]+qlm_hl[3][3];
// 
// 
//   tau[1][1]=qlm_hl[1][1]-hl_qlm[1][1]+(-XI*(hl_qlm[1][1]+qlm_hl[1][1]+2.f/3.f*hl[1][1])+2.f*XI*(qlm[1][1]+1/3.f)*trQH ) -ZETA*qlm[1][1];				//calculate local stress tensor
//   tau[2][2]=qlm_hl[2][2]-hl_qlm[2][2]+(-XI*(hl_qlm[2][2]+qlm_hl[2][2]+2.f/3.f*hl[2][2])+2.f*XI*(qlm[2][2]+1/3.f)*trQH ) -ZETA*qlm[2][2];
//   tau[3][3]=qlm_hl[3][3]-hl_qlm[3][3]+(-XI*(hl_qlm[3][3]+qlm_hl[3][3]+2.f/3.f*hl[3][3])+2.f*XI*(qlm[3][3]+1/3.f)*trQH ) -ZETA*qlm[3][3];
//   tau[1][2]=qlm_hl[1][2]-hl_qlm[1][2]+(-XI*(hl_qlm[1][2]+qlm_hl[1][2]+2.f/3.f*hl[1][2])+2.f*XI*(qlm[1][2])*trQH ) -ZETA*qlm[1][2];
//   tau[1][3]=qlm_hl[1][3]-hl_qlm[1][3]+(-XI*(hl_qlm[1][3]+qlm_hl[1][3]+2.f/3.f*hl[1][3])+2.f*XI*(qlm[1][3])*trQH ) -ZETA*qlm[1][3];
//   tau[2][3]=qlm_hl[2][3]-hl_qlm[2][3]+(-XI*(hl_qlm[2][3]+qlm_hl[2][3]+2.f/3.f*hl[2][3])+2.f*XI*(qlm[2][3])*trQH ) -ZETA*qlm[2][3];
//   tau[2][1]=qlm_hl[2][1]-hl_qlm[2][1]+(-XI*(hl_qlm[1][2]+qlm_hl[1][2]+2.f/3.f*hl[1][2])+2.f*XI*(qlm[1][2])*trQH ) -ZETA*qlm[2][1];
//   tau[3][1]=qlm_hl[3][1]-hl_qlm[3][1]+(-XI*(hl_qlm[1][3]+qlm_hl[1][3]+2.f/3.f*hl[1][3])+2.f*XI*(qlm[1][3])*trQH ) -ZETA*qlm[3][1];
//   tau[3][2]=qlm_hl[3][2]-hl_qlm[3][2]+(-XI*(hl_qlm[2][3]+qlm_hl[2][3]+2.f/3.f*hl[2][3])+2.f*XI*(qlm[2][3])*trQH ) -ZETA*qlm[3][2];
// }

void izrOdvAStressL(int l,float *divTaul){
  
  
  int lp,lm;
  float fak;

//   float taup[4][4],taum[4][4];
  float DTAUl[4][4];
  
  fak=0.5f;	//TAU needs to be calculated only for LMARK1 markers

  lp=l+1; lm=l-1;	
  if(!(LMARK[lm]&(LMARK1))) {lm=l,fak=1.f;} else if(!(LMARK[lp]&LMARK1)) {lp=l;fak=1.f;};
//   izrAStressL(lp,taup);									//calculate stress in lxp nad lxm points
//   izrAStressL(lm,taum);
  DTAUl[1][1]=fak*(TAU[1][lp]-TAU[1][lm]);							//calculate derivatives of stress point: eg DTAU[2][1]=DTau_yx /dx
  DTAUl[2][1]=fak*(TAU[7][lp]-TAU[7][lm]);
  DTAUl[3][1]=fak*(TAU[8][lp]-TAU[8][lm]);

  lp=l+I; lm=l-I;
  if(!(LMARK[lm]&LMARK1)) {lm=l,fak=1.f;} else if(!(LMARK[lp]&LMARK1)) {lp=l;fak=1.f;};
//   izrAStressL(lp,taup);									//calculate stress in lyp nad lym points
//   izrAStressL(lm,taum);
  DTAUl[1][2]=fak*(TAU[4][lp]-TAU[4][lm]);							//calculate derivatives of stress point: eg DTAU[2][1]=DTau_yx /dx
  DTAUl[2][2]=fak*(TAU[2][lp]-TAU[2][lm]);
  DTAUl[3][2]=fak*(TAU[9][lp]-TAU[9][lm]);

  lp=l+I*J; lm=l-I*J;
  if(!(LMARK[lm]&LMARK1)) {lm=l,fak=1.f;} else if(!(LMARK[lp]&LMARK1)) {lp=l;fak=1.f;};
//   izrAStressL(lp,taup);									//calculate stress in lyp nad lym points
//   izrAStressL(lm,taum);
  DTAUl[1][3]=fak*(TAU[5][lp]-TAU[5][lm]);							//calculate derivatives of stress point: eg DTAU[2][1]=DTau_yx /dx
  DTAUl[2][3]=fak*(TAU[6][lp]-TAU[6][lm]);
  DTAUl[3][3]=fak*(TAU[3][lp]-TAU[3][lm]);

  divTaul[1]=DTAUl[1][1]+DTAUl[1][2]+DTAUl[1][3];
  divTaul[2]=DTAUl[2][1]+DTAUl[2][2]+DTAUl[2][3];
  divTaul[3]=DTAUl[3][1]+DTAUl[3][2]+DTAUl[3][3];
}

//Funkcija, ki izracuna odvode stress tenzorja
// void izrOdvAStressL(int l,float *divTaul){
//   
//   
//   int lp,lm;
//   float fak;
// 
//   float taup[4][4],taum[4][4], DTAUl[4][4];
//   
//   fak=0.5f;	//TAU moras izracunati le na LMARK1 markerjih
// 
//   lp=l+1; lm=l-1;	
//   if(!(LMARK[lm]&(LMARK1))) {lm=l,fak=1.f;} else if(!(LMARK[lp]&LMARK1)) {lp=l;fak=1.f;};
//   izrAStressL(lp,taup);									//calculate stress in lxp nad lxm points
//   izrAStressL(lm,taum);
//   DTAUl[1][1]=fak*(taup[1][1]-taum[1][1]);							//calculate derivatives of stress point: eg DTAU[2][1]=DTau_yx /dx
//   DTAUl[2][1]=fak*(taup[2][1]-taum[2][1]);
//   DTAUl[3][1]=fak*(taup[3][1]-taum[3][1]);
// 
//   lp=l+I; lm=l-I;
//   if(!(LMARK[lm]&LMARK1)) {lm=l,fak=1.f;} else if(!(LMARK[lp]&LMARK1)) {lp=l;fak=1.f;};
//   izrAStressL(lp,taup);									//calculate stress in lyp nad lym points
//   izrAStressL(lm,taum);
//   DTAUl[1][2]=fak*(taup[1][2]-taum[1][2]);							//calculate derivatives of stress point: eg DTAU[2][1]=DTau_yx /dx
//   DTAUl[2][2]=fak*(taup[2][2]-taum[2][2]);
//   DTAUl[3][2]=fak*(taup[3][2]-taum[3][2]);
// 
//   lp=l+I*J; lm=l-I*J;
//   if(!(LMARK[lm]&LMARK1)) {lm=l,fak=1.f;} else if(!(LMARK[lp]&LMARK1)) {lp=l;fak=1.f;};
//   izrAStressL(lp,taup);									//calculate stress in lyp nad lym points
//   izrAStressL(lm,taum);
//   DTAUl[1][3]=fak*(taup[1][3]-taum[1][3]);							//calculate derivatives of stress point: eg DTAU[2][1]=DTau_yx /dx
//   DTAUl[2][3]=fak*(taup[2][3]-taum[2][3]);
//   DTAUl[3][3]=fak*(taup[3][3]-taum[3][3]);
// 
//   divTaul[1]=DTAUl[1][1]+DTAUl[1][2]+DTAUl[1][3];
//   divTaul[2]=DTAUl[2][1]+DTAUl[2][2]+DTAUl[2][3];
//   divTaul[3]=DTAUl[3][1]+DTAUl[3][2]+DTAUl[3][3];
// }


//Computes equilibrium distribution function
void izrFeq(float **feq){
  float ue,u2;
  int m;
  
  float Ul2[5]; //Local matrices

  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500) private(Ul2,ue,u2,m)			//Parallelisation -- (static, 20000) is recommended by David Seč (not necessarily the best option)
  for(int l=0;l<NMAX;l++){
    if(!(LMARK[l]==LMARK1)) continue;
    fillUl2(l,Ul2);			//Save global values from U to a local variable Ul2
    u2=fsqr(Ul2[1]) + fsqr(Ul2[2]) + fsqr(Ul2[3]);	//Velocity squared
    
    for(m=0;m<ST_HITROSTI;m++){
      ue=Ul2[1]*E[m][1] + Ul2[2]*E[m][2] + Ul2[3]*E[m][3];		//Product of velocity and characteristic vectors
      feq[m][l]=WKONST[m]*Ul2[4]*(1.f+3.f*ue+9.f/2.f*fsqr(ue)-1.5*u2);
    }
  }
}



//Computes the forcing P
void izrP(){
  int l,m;
  
  float Ul2[5];
  float Dxx2[7],Dyy2[7],Dzz2[7],Dx2[7],Dy2[7],Dz2[7]; //Vectors, where the derivatives are stored
  float divTaul[4];  //Divergence of the stress tensor
  
  compute_stress_tensor(); 
  
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500) private(m,Dxx2,Dyy2,Dzz2,Dx2,Dy2,Dz2,Ul2, divTaul)
  for(l=0;l<NMAX;l++){
    if(!(LMARK[l]==LMARK1)) continue;
    fillUl2(l,Ul2);		//Fill local values of U
    izrOdvQ2(l,Dxx2,Dyy2,Dzz2,Dx2,Dy2,Dz2);	//Calculate derivatives in Q
        
    izrOdvAStressL(l,divTaul);		//Calculate the divergence of the stress tensor

    
    
    float Fx=0,Fy=0,Fz=0;
    for(m=1;m<4;m++){ Fx-=H[m][l]*Dx2[m]; Fy-=H[m][l]*Dy2[m]; Fz-=H[m][l]*Dz2[m];}	//Alternative description of stress tensor (Lisbon version) -- truly incompressible nematic
    for(m=4;m<7;m++){ Fx-=2*H[m][l]*Dx2[m]; Fy-=2*H[m][l]*Dy2[m]; Fz-=2*H[m][l]*Dz2[m];}
//     for(m=1;m<4;m++){ Fx-=(Dxx2[m]+Dyy2[m]+Dzz2[m])*Dx2[m]; Fy-=(Dxx2[m]+Dyy2[m]+Dzz2[m])*Dy2[m]; Fz-=(Dxx2[m]+Dyy2[m]+Dzz2[m])*Dz2[m];}
//     for(m=4;m<7;m++){ Fx-=2*(Dxx2[m]+Dyy2[m]+Dzz2[m])*Dx2[m]; Fy-=2*(Dxx2[m]+Dyy2[m]+Dzz2[m])*Dy2[m]; Fz-=2*(Dxx2[m]+Dyy2[m]+Dzz2[m])*Dz2[m];}
    float forceX, forceY, forceZ;
    forceX=divTaul[1] +Fx; FORCE[1][l]=forceX;	//First moment of forcing has contributions from TAU stress tensor and free energy derivatives as well. Velocity is corrected by the factor of FORCE
    forceY=divTaul[2] +Fy; FORCE[2][l]=forceY;
    forceZ=divTaul[3] +Fz; FORCE[3][l]=forceZ;
    for(m=0;m<ST_HITROSTI;m++){
      float ue=Ul2[1]*E[m][1] + Ul2[2]*E[m][2] + Ul2[3]*E[m][3];		//Product of the velocity and the characteristic vectors
      float eF=E[m][1]*forceX + E[m][2]*forceY +E[m][3]*forceZ;
      float uF=Ul2[1]*forceX  + Ul2[2]*forceY  + Ul2[3]*forceZ;
      P[m][l]=(1.f-DT/2.f/TAUF)*WKONST[m]*( 3.f*eF - 3.f*uF + 9.f *ue*eF );
      //P[m][l]=0;
    }

  }
}




//Transcribes velocity field to a local variable
void fillUl2(int l, float* ul){
  ul[1]=U[1][l];
  ul[2]=U[2][l];
  ul[3]=U[3][l];
  ul[4]=U[4][l];

}


//Computes streaming location
int calcLBlnew(int l, int m){
  int i,j,k;
  
  i=i_vr(l)+E[m][1];
  j=j_vr(l)+E[m][2];
  k=k_vr(l)+E[m][3];

  return i+j*I+k*I*J;
}


//Computes bounce-back location
 int calcLBmnew(int m){
  if(m%2==0) return m-1;		//Opposite vectors are arranged in odd-even order
  else return m+1;
}

/*
//No-slip bounce-back for horizontal plane
 int calcLBmnew_noslipZ(int m){
  if(m==5) return 6; else if(m==6) return 5; else if(m==11) return 14; else if(m==14) return 11; else if(m==12) return 13; else if(m==13) return 12; else if(m==15) return 18; else if(m==18) return 15; else if(m==16) return 17; else if(m==17) return 16; else return 0;
}*/

// Periodic BC
int calcLpbc(int l){
  int xp2=0, yp2=0, zp2=0;	//Normal pbc
   
  if(i_vr(l)==0) xp2=I-2;
  if(i_vr(l)==I-1) xp2=-(I-2);
  if(j_vr(l)==0) yp2=I*(J-2);
  if(j_vr(l)==J-1) yp2=-I*(J-2);
  if(k_vr(l)==0) zp2=I*J*(K-2);
  if(k_vr(l)==K-1) zp2=-I*J*(K-2);
      
  return (l+ xp2 + yp2 + zp2);
}


// Open BC
// int calcLpbc(int l){
//    int xp2=0, yp2=0, zp2=0;    //Open pbc
// 
//    if(i_vr(l)==0) xp2=1;
//    if(i_vr(l)==I-1) xp2=-1;
//    if(j_vr(l)==0) yp2=I;
//    if(j_vr(l)==J-1) yp2=-I;
//    if(k_vr(l)==0) zp2=I*J;
//    if(k_vr(l)==K-1) zp2=-I*J;
// 
//    return (l+ xp2 + yp2 + zp2);
// }

//Makes periodic boundary conditions and forces the pressure gradient
void pbcLB(){
  #ifdef DELTAP
  float rho_outletj=0.f, rho_inletj=0.f;
  int j=0;
  float rho_outleti=0.f, rho_inleti=0.f;
  int i=0;
  for(int l=0;l<NMAX;l++){
    if(j_vr(l)==1 && (LMARK[l]==LMARK1)){ rho_inletj+=U[4][l]; j++;}
    else if(j_vr(l)==J-2  && (LMARK[l]==LMARK1)) rho_outletj+=U[4][l];
    if(i_vr(l)==1 && (LMARK[l]==LMARK1)){ rho_inleti+=U[4][l]; i++;}
    else if(i_vr(l)==I-2  && (LMARK[l]==LMARK1)) rho_outleti+=U[4][l];
  }
  rho_inletj/=j;
  rho_outletj/=j;
  rho_inleti/=i;
  rho_outleti/=i;
  #endif
  
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500)
  for(int l=0; l<NMAX; l++){
    if(LMARK[l]&LMARKRP){
      int lpbc=calcLpbc(l); //if(LMARK[l]&LMARK1 && !(LMARK[lpbc]&LMARK1)){ printf("Napacna alokacija in RP!!!"); exit(1);}	

      if(LMARK[l]&LMARK1){
	float feqnew=0;
	for(int m=0; m<ST_HITROSTI; m++){
	  #ifdef DELTAP
	  if(j_vr(l)==0) feqnew=WKONST[m]*(DENSITYINIT+DELTAPY*(1.f/2.f+1.f/J/2)-rho_outletj);
	  else if(j_vr(l)==J-1) feqnew=WKONST[m]*(DENSITYINIT-DELTAPY*(1.f/2.f+1.f/J/2)-rho_inletj);
	  else if(i_vr(l)==0) feqnew=WKONST[m]*(DENSITYINIT+DELTAPX*(1.f/2.f+1.f/I/2)-rho_outleti);
	  else if(i_vr(l)==I-1) feqnew=WKONST[m]*(DENSITYINIT-DELTAPX*(1.f/2.f+1.f/I/2)-rho_inleti);
	  #endif

	  P[m][l]=P[m][lpbc]; FEQ[m][l]=FEQ[m][lpbc]+feqnew; F[m][l]=F[m][lpbc]+feqnew;}
      }
    }
  }
}

//Time step in LB
void izrCasKorU(){
  int l,m;
  int lnew,mnew;		//Where the function is streamed
  
  izrFeq(FEQ);		//Computes equilibrium distribution
  izrP();           //Computes forcing
  
  pbcLB();		//PBC

  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500) private(lnew,m)
  for(l=0;l<NMAX;l++){
    if( ((LMARK[l]&LMARK1))){
      for(m=0;m<ST_HITROSTI;m++){
	lnew=calcLBlnew(l,m);
	if(lnew>=0 && lnew<NMAX) FNEW[m][lnew]=F[m][l]-DT/TAUF*(F[m][l]-FEQ[m][l]) + P[m][l];		//Streaming and collision
      }
    }
  }
  
  
  //bounce back -- implementation of surfaces
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500) private(lnew,m,mnew)
  for(l=0;l<NMAX;l++){	//bounce-back
    if(!(LMARK[l]&LMARK1) && !(LMARK[l]&LMARK0) ){
      for(m=1;m<ST_HITROSTI;m++){
	//mnew=calcLBmnew_noslipZ(m);		//Bounce back at the boundary
	//lnew=calcLpbc(calcLBlnew(l,mnew));	//To which point the function is returned
	mnew=calcLBmnew(m);		//Bounce back at the boundary
	lnew=calcLBlnew(l,mnew);	//To which point the function is returned
	int lnewE=calcLBlnew(lnew,mnew); //Point E for interpolation
	if(lnew>=0 && lnew<NMAX && (LMARK[lnew]==(LMARK1)) ) {	//If function is streamed to the bulk
	  //Bounce back is based on Bouzidi, Phys Fluid 2001	Factor is conneced to the form of FEQ (B)
//  	  FNEW[mnew][lnew]=FNEW[m][l]-2.f*3.f*WKONST[m]*U[4][lnew]*(E[m][1]*UNIC[1][l]+E[m][2]*UNIC[2][l]+E[m][3]*UNIC[3][l]);		//No interpolation, surface at 1/2
	  FNEW[mnew][lnew]=0.5f*FNEW[m][l]+0.5f*FNEW[mnew][calcLBlnew(lnew,mnew)]/*;//*/ - 3.f*WKONST[m]*U[4][lnew]*(E[m][1]*UNIC[1][l]+E[m][2]*UNIC[2][l]+E[m][3]*UNIC[3][l]);	//Interpolation at q=1
	  //FNEW[mnew][lnew]=FNEW[m][lnew];			//Interpolation at q=0
	}
      }
    }
  }
 
  
  calcFNEW2F();
  
  //Calculate velocity profile
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500)
  for(l=0;l<NMAX;l++) {calcF2Ul(l,F); /*printf("%d; %f ",LMARK[l], U[1][l]);*/}; 
  
  
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500)
  for(l=0;l<NMAX;l++) for(int m=1; m<5; m++) U[m][l]=U[m][calcLpbc(l)]; 
}

//The main function for the coupled dynamics
void izrQU(){
  int t;
  char buf[200]; 
  double fe;
  FILE *free_energy;
  float x,y,z,r;
  
  //struct ALL ACTIVE DROPLET VARIABLES
  ActiveDropletVariables act_var;
  ActiveDropletVariables* active_var = &act_var;
  active_droplet_var(active_var);

 
  //struct init SPHERE
  ActiveDroplet sphere1;
  ActiveDroplet* sphere1_ptr = &sphere1;
  
  double center1[3] = {0, 0, 0};
  sphere1.center = center1;
  sphere1.radius = R;
  init_droplet(sphere1_ptr);
  printf("Len after init: %d\n", sphere1.num_points);
  //     gradU=matrix(1,3,0,sphere1.num_points-1);


  //struct FIBONACCI
  FibonacciLattice sphere_lattice;
  FibonacciLattice* init_sphere_lattice = &sphere_lattice;
  fibonacci_init(init_sphere_lattice, 100, center1, R); 
  printf("Fibonacci num_points: %d\n", sphere_lattice.num_points);
    
    

    
    
  //Initial time-steps in the Q-tensor. Mostly not needed.
  for(t=0;t<STCASKORINIT;t++){
    if(t%STKONV==0){
    #if TWRITEDIR
      //sprintf(buf,"./data/%s_dir_%07d-INIT.raw", imeIzpis,t);	zapisQ2DIRraw(buf);
      sprintf(buf,"./data/%s_op-INIT_%07d.raw",imeIzpis, t);		zapisQ2OPraw(buf);
    #endif 
    }
    izrCasKorQ();	//A time step of the Q-tensor dynamics
  }
  
  
  //The main dynamics
  for(t=0;t<STCASKOR;t++){
     
    if(t%STKONV==0){      
    #if TWRITEU
      sprintf(buf,"./data/%s_u_%07d.vtk", imeIzpis,t);		zapisUraw(buf);
    #endif
//     #if TWRITEDEN
//       sprintf(buf,"./data/%s_den_%07d.vtk", imeIzpis,t);	zapisDENraw(buf);
//     #endif
//     #if TWRITEDIR
//       sprintf(buf,"./data/%s_dir_%07d.vtk", imeIzpis,t);	zapisQ2DIRraw(buf);
//     #endif 
    #if TWRITEOP
      sprintf(buf,"./data/%s_op_%07d.vtk",imeIzpis, t);		zapisQ2OPraw(buf);
    #endif
    #if TWRITEQ
      sprintf(buf,"./data/%s_Q_%07d.raw",imeIzpis, t);		zapisQ(buf);
    #endif
    #if TWRITELOC
      sprintf(buf,"./data/%s_locDefect_%07d.txt",imeIzpis, t);		locDefect(&sphere1,buf);
      
      sprintf(buf,"./data/%s__%07d.txt",imeIzpis, t);		locDefect(&sphere1,buf);
    #endif
    
    }
    
    if(t%STKONVV==0){      
    #if TWRITEDEN
      sprintf(buf,"./data/%s_den_%07d.vtk", imeIzpis,t);	zapisDENraw(buf);
    #endif
    #if TWRITEDIR
      sprintf(buf,"./data/%s_dir_%07d.vtk", imeIzpis,t);	zapisQ2DIRraw(buf);
    #endif 
    }
    
    if(t%STKONG==0){
    #if TWRITEgrad
        zapis_all_grad(&sphere1);
        zapis_fibonacci_average_velocity(&sphere1, &sphere_lattice, &act_var);
        zapisDistance();
    #endif
    }
        
    if(t%STDVF==0){
    #if TWRITEDVF
        zapisDVF(buf);
    #endif   
    }
    
    if(t%STFE==0){
    #if TWRITEFE
//         zapisFE(buf);
        fe=calculate_free_energy();
        free_energy=fopen("./data/free_energy.txt","a");
        
        if(free_energy==NULL){
            fprintf(stderr, "Failed opening file. a mode. file=%s\n", "./free_energy.txt");
            exit(1); 
        }
        
        fprintf(free_energy, "%d;%lf\n",t,fe);
        printf("%d,%lf\n", t,fe);
        fclose(free_energy);
    #endif
    }
    
    if(t%STCOPY==0){
    #if TWRITECOPY
        sprintf(buf, "%s_DATA.bin", imeIzpis); zapisDATA(buf);
    #endif    
    } 
    

    
    
    for(int i=0; i<STCASKORQ; i++) izrCasKorQ(); //Q-tensor time step


    
//hitrostno polje
    izrCasKorU();	//LB time step
    
    

    //surface velocity vX, vY, vZ
    velocity_sphere(&sphere1, &act_var);
//     velocity_sphere(&sphere1,0.0001,2);

    velocity_grad(&sphere1);
//     defect_grad(&sphere1);
    
    if(t%STKONV==0){ 
    #if TWRITEU
      sprintf(buf,"./data/%s_grad_%07d.vtk", imeIzpis,t);		zapisUgrad(buf);
//       sprintf(buf,"./data/%s_gradDefect_%07d.vtk", imeIzpis,t);		zapisUgradDEFECT(buf);
    #endif
    }
    
    



    
    
  }
}
