//Sets up the initial condition for the Q-tensor, QNIC tensor and logical markers LMARK in each datapoint
void zacPriblQ(long seed){
  int l;
  float x,y,z,r;
  int t;
 
  for(l=0;l<NMAX;l++){
    x=i_vr(l)-(I-1.f)/2.f;
    y=j_vr(l)-(J-1.f)/2.f;
    z=k_vr(l)-(K-1.f)/2.f;
        
    r=sqrt(fsqr(x) + fsqr(y) + fsqr(z));

    if(fsqr(x) + fsqr(y) + fsqr(z)<=fsqr(R)) dir2QRP(l,x/r,y/r,z/r,  x/r,y/r,z/r,  0.f,0.f,0.f,LMARKPOV, seed);
    else if(k_vr(l) == 0 || k_vr(l) == 1) dir2QRP(l,1.f,0.f,0.f,  1.f,0.f,0.f,  0.f,0.f,0.f,LMARKPOV, seed);
    else if(k_vr(l) == K-1 || k_vr(l) == K-2) dir2QRP(l,-1.f,0.f,0.f,  -1.f,0.f,0.f,  0.f,0.f,0.f,LMARKPOV, seed);
       
    else 
    dir2QBulk(l, seed);
  }
  
  
  for(l=0;l<NMAX;l++){
	int lxp,lxm,lyp,lym,lzp,lzm;
	if(i_vr(l)==0) {lxp=l+1; lxm=l+I-1;}		//periodicnost po x smeri
	else if(i_vr(l)==I-1) {lxp=l-(I-1); lxm=l-1;}
	else {lxp=l+1; lxm=l-1;};

	if(j_vr(l)==0) {lyp=l+I; lym=l+(J-1)*I;}	//periodicnost po y smeri
	else if(j_vr(l)==J-1) {lyp=l-(J-1)*I; lym=l-I;}
	else {lyp=l+I; lym=l-I;};

	if(k_vr(l)==0) {lzp=l+I*J; lzm=l+(K-1)*I*J;}	//periodicnost po z smeri
	else if(k_vr(l)==K-1) {lzp=l-(K-1)*I*J; lzm=l-I*J;}
	else {lzp=l+I*J; lzm=l-I*J;}; 
    
	
	if(LMARK[lxp]&(LMARKPOV|LMARKKOL) && LMARK[lxm]&(LMARKPOV|LMARKKOL) && LMARK[lyp]&(LMARKPOV|LMARKKOL) && LMARK[lym]&(LMARKPOV|LMARKKOL) && LMARK[lzp]&(LMARKPOV|LMARKKOL) && LMARK[lzm]&(LMARKPOV|LMARKKOL)){ LMARK[l]=(LMARKKOL|LMARK0);}
  }

  for(l=0;l<NMAX;l++){
    if(i_vr(l)==0 || i_vr(l)==I-1 || j_vr(l)==0 || j_vr(l)==J-1 || k_vr(l)==0 || k_vr(l)==K-1) LMARK[l]=(LMARK[l]|LMARKRP);														
    else if(LMARK[l]&LMARKKOL) for(int m=1; m<ST_HITROSTI; m++) if(LMARK[calcLBlnew(l, m)]&(LMARK1|LMARKPOV)) LMARK[l]=LMARKKOL;
  }


}


//Initialise boundary condition on the surfaces
void dir2QRP(int l, float dirX, float dirY, float dirZ, float nX, float nY, float nZ, float vX, float vY, float vZ, char lmark, long seed){
  float seq=SEQ;
  float x,y,z;
  int count=0;
  
  LMARK[l]=lmark;
  
  UNIC[1][l]=vX;		//surface velocity
  UNIC[2][l]=vY;
  UNIC[3][l]=vZ;
  
 
  float norma=sqrt(fsqr(nX)+fsqr(nY)+fsqr(nZ));
  if(norma==0) norma=1.f;
  QNIC[4][l]=nX/norma;
  QNIC[5][l]=nY/norma;
  QNIC[6][l]=nZ/norma;
  

  x=(float)(i_vr(l))-(float)(I-1)/2+0.001;
  y=(float)(j_vr(l))-(float)(J-1)/2+0.001;
  z=(float)(k_vr(l))-(float)(K-1)/2+0.001;
//   if(fsqr(x)+fsqr(y)<fsqr(I/2-3)) {dirZ=cos(z/K*M_PI),dirY=0,dirX=sin(z/K*M_PI);}
//   else {dirX=1; dirY=0; dirZ=0;};
  
//   norma=sqrt(fsqr(dirX)+fsqr(dirY)+fsqr(dirZ));
//   if(norma==0) norma=1.f;
//   dirX=dirX/norma;//x/sqrt(x*x+y*y+z*z);
//   dirY=dirY/norma;//y/sqrt(x*x+y*y+z*z);
//   dirZ=dirZ/norma;//z/sqrt(x*x+y*y+z*z);
//   

//   vX=y/sqrt(x*x+y*y+z*z);
  
  
  
//   dirX=x/sqrt(x*x+y*y+z*z);
//   dirY=y/sqrt(x*x+y*y+z*z);
//   dirZ=z/sqrt(x*x+y*y+z*z);
  

  QNIC[1][l]=dirX;
  QNIC[2][l]=dirY;
  QNIC[3][l]=dirZ;
//   dirX=0; dirY=0; dirZ=1;
  
  
  
//   //random director
//   float phi, theta;
//   phi=ran2(&seed)*2*M_PI;
//   theta=acos(2*(ran2(&seed))-1);
//   
// //   x=cos(phi)*sin(theta);
// //   y=sin(phi)*sin(theta);
// //   z=cos(theta);
//   
//   dirX=x/sqrt(x*x+y*y+z*z);
//   dirY=y/sqrt(x*x+y*y+z*z);
//   dirZ=z/sqrt(x*x+y*y+z*z);
  
 
  
  Q[1][l]=0.5f*seq*(3*dirX*dirX-1);
  Q[2][l]=0.5f*seq*(3*dirY*dirY-1);
  Q[3][l]=0.5f*seq*(3*dirZ*dirZ-1);
  Q[4][l]=1.5f*seq*(dirX*dirY);
  Q[5][l]=1.5f*seq*(dirX*dirZ);
  Q[6][l]=1.5f*seq*(dirY*dirZ);
}


//Initialise boundary condition in the bulk
void dir2QBulk(int l,long seed){
  LMARK[l]=LMARK1;
  float dirX, dirY, dirZ;
  float seq=SEQ;//ran2(&seed)*1e-30;
  float x,y,z;
  
  
//   x=(float)(i_vr(l))-(float)(I-1)/2+0.001;
//   y=(float)(j_vr(l))-(float)(J-1)/2+0.001;
//   z=(float)(k_vr(l))-(float)(K-1)/2+0.001;

//   //loop
//   if(fsqr(x)+fsqr(y)<fsqr(1/8)) {dirZ=cos(z/K*M_PI),dirY=0,dirX=sin(z/K*M_PI);}
//   dirX=0; dirY=0; dirZ=1;
  

  float q, e_x, r;
  
  q=1.2;
  e_x=1.0;
  
  
  
  
  x=(float)(i_vr(l))-(float)(I-1)/2+0.001;
  y=(float)(j_vr(l))-(float)(J-1)/2+0.001;
  z=(float)(k_vr(l))-(float)(K-1)/2+0.001;
  
  r=sqrt(x*x+y*y+z*z)*sqrt(x*x+y*y+z*z)*sqrt(x*x+y*y+z*z);
  
  dirX=e_x+q*R*R*x/r;
  dirY=+q*R*R*y/r;
  dirZ=+q*R*R*z/r;
 
  
//   x=1;
//   y=0;
//   z=1;
//   
//   dirX=x/sqrt(x*x+y*y+z*z);
//   dirY=y/sqrt(x*x+y*y+z*z);
//   dirZ=z/sqrt(x*x+y*y+z*z);
  
  
//   
// 
//   QNIC[1][l]=dirX;
//   QNIC[2][l]=dirY;
//   QNIC[3][l]=dirZ;
  
  
  Q[1][l]=0.5f*seq*(3*dirX*dirX-1);
  Q[2][l]=0.5f*seq*(3*dirY*dirY-1);
  Q[3][l]=0.5f*seq*(3*dirZ*dirZ-1);
  Q[4][l]=1.5f*seq*(dirX*dirY);
  Q[5][l]=1.5f*seq*(dirX*dirZ);
  Q[6][l]=1.5f*seq*(dirY*dirZ);
  
  UNIC[1][l]=0;		//in the bulk, surface velocity is zero
  UNIC[2][l]=0;
  UNIC[3][l]=0;

}


//Compute local Q-tensor derivatives
void izrOdvQ2(int l, float* dxx, float* dyy, float* dzz, float* dx, float* dy, float* dz){
  int i,lxp,lxm,lyp,lym,lzp,lzm;

	
	lxp=l+1; lxm=l-1;
	lyp=l+I; lym=l-I;
	lzp=l+I*J; lzm=l-I*J;


	for(i=1;i<=6;i++)				//derivatives of Q. Watch out: 2. derivatives are calculated only in the bulk
	{
	  
		dxx[i]=(Q[i][lxp]+Q[i][lxm]-2*Q[i][l]);
		dyy[i]=(Q[i][lyp]+Q[i][lym]-2*Q[i][l]);
		dzz[i]=(Q[i][lzp]+Q[i][lzm]-2*Q[i][l]);
	  

		dx[i]=0.5f*(Q[i][lxp]-Q[i][lxm]);
		dy[i]=0.5f*(Q[i][lyp]-Q[i][lym]);
		dz[i]=0.5f*(Q[i][lzp]-Q[i][lzm]);
	};

	
}

//Compute forward derivative of the Q-tensor on the surface
void izrOdvQ2POV(int l, float* dx, float* dy, float* dz){
  int i,lxp,lxm,lyp,lym,lzp,lzm,lsxp,lsxm,lsyp,lsym,lszp,lszm;
	float fakX=0.5,fakY=0.5,fakZ=0.5;
	
	lxp=l+1; lxm=l-1;
	lyp=l+I; lym=l-I;
	lzp=l+I*J; lzm=l-I*J;

	lsxp=lxp; lsxm=lxm; lsyp=lyp; lsym=lym; lszp=lzp; lszm=lzm;


		if(LMARK[lxm]&LMARKKOL) {lsxp=lxp;lsxm=l;fakX=1.;}
		else if(LMARK[lxp]&LMARKKOL) {lsxp=l;lsxm=lxm;fakX=1.;};

		if(LMARK[lym]&LMARKKOL) {lsyp=lyp;lsym=l;fakY=1.;}
		else if(LMARK[lyp]&LMARKKOL) {lsyp=l;lsym=lym;fakY=1.;};

		if(LMARK[lzm]&LMARKKOL) {lszp=lzp;lszm=l;fakZ=1.;}
		else if(LMARK[lzp]&LMARKKOL) {lszp=l;lszm=lzm;fakZ=1.;};


	for(i=1;i<=6;i++)				//derivatives of Q
	{

		dx[i]=fakX*(Q[i][lsxp]-Q[i][lsxm]);
		dy[i]=fakY*(Q[i][lsyp]-Q[i][lsym]);
		dz[i]=fakZ*(Q[i][lszp]-Q[i][lszm]);
	};

	
}

//free energy
double calculate_free_energy(){
  
  double free_energy=0;
  #pragma omp parallel for reduction (+:free_energy)
  for(int l=0;l<NMAX;l++){
      
    if(LMARK[l]==LMARK1){
      float Dxx2[7],Dyy2[7],Dzz2[7],Dx2[7],Dy2[7],Dz2[7],Dxy2[7],Dxz2[7],Dyz2[7];
      izrOdvQ2(l,Dxx2,Dyy2,Dzz2,Dx2,Dy2,Dz2);
//       izrOdvQ2(l,Dxx2,Dyy2,Dzz2,Dxy2,Dxz2,Dyz2,Dx2,Dy2,Dz2);

      free_energy+=
	//L1 part
	0.5*( sqr(Dx2[1]) + sqr(Dx2[2]) +sqr(Dx2[3]) + 2*sqr(Dx2[4]) + 2*sqr(Dx2[5]) + 2*sqr(Dx2[6]) 
	+ sqr(Dy2[1]) + sqr(Dy2[2]) +sqr(Dy2[3]) + 2*sqr(Dy2[4]) + 2*sqr(Dy2[5]) + 2*sqr(Dy2[6])
        + sqr(Dz2[1]) + sqr(Dz2[2]) +sqr(Dz2[3]) + 2*sqr(Dz2[4]) + 2*sqr(Dz2[5]) + 2*sqr(Dz2[6]))
// 	//L2 part
// 	+0.5*L21*(sqr(Dx2[1]) +sqr(Dx2[4]) +sqr(Dx2[5]) +sqr(Dy2[2]) +sqr(Dy2[4]) +sqr(Dy2[6]) +sqr(Dz2[3]) +sqr(Dz2[5]) +sqr(Dz2[6]) +2*Dz2[6]*Dy2[2] +2*Dz2[5]*Dy2[3] +2*Dz2[3]*Dy2[6] +2*Dz2[5]*Dx2[1] +2*Dy2[4]*Dx2[1] +2*Dz2[6]*Dx2[4] +2*Dy2[2]*Dx2[4] +2*Dz2[3]*Dx2[5] +2*Dy2[6]*Dx2[5]	      )
// 	//Cholesteric part
// 	+2*q0*(
// 		+Q[4][l]*Dz2[1]
// 		-Q[4][l]*Dz2[2]
// 		+Q[2][l]*Dz2[4]
// 		-Q[1][l]*Dz2[4]
// 		+Q[6][l]*Dz2[5]
// 		-Q[5][l]*Dz2[6]
// 		
// 		+Q[5][l]*Dy2[3]
// 		-Q[5][l]*Dy2[1]
// 		+Q[1][l]*Dy2[5]
// 		-Q[6][l]*Dy2[4]
// 		+Q[4][l]*Dy2[6]
// 		-Q[3][l]*Dy2[5]
// 
// 		+Q[6][l]*Dx2[2]
// 		-Q[6][l]*Dx2[3]
// 		+Q[5][l]*Dx2[4]
// 		-Q[4][l]*Dx2[5]
// 		+Q[3][l]*Dx2[6]
// 		-Q[2][l]*Dx2[6]
// 
// 		)
	//Phase part
        + 0.5*A*(sqr(Q[1][l])+sqr(Q[2][l])+sqr(Q[3][l])+2*sqr(Q[4][l])+2*sqr(Q[5][l])+2*sqr(Q[6][l]))
					+B/3.*(Q[1][l]*(sqr(Q[1][l])+sqr(Q[4][l])+sqr(Q[5][l]))+Q[2][l]*(sqr(Q[2][l])+sqr(Q[4][l])+sqr(Q[6][l]))+Q[3][l]*(sqr(Q[3][l])+sqr(Q[5][l])+sqr(Q[6][l]))+2*Q[6][l]*(Q[4][l]*Q[5][l]+Q[2][l]*Q[6][l]+Q[3][l]*Q[6][l])+2*Q[5][l]*(Q[1][l]*Q[5][l]+Q[3][l]*Q[5][l]+Q[4][l]*Q[6][l])+2*Q[4][l]*(Q[1][l]*Q[4][l]+Q[2][l]*Q[4][l]+Q[5][l]*Q[6][l]))
					+0.25*C*sqr(sqr(Q[1][l])+sqr(Q[2][l])+sqr(Q[3][l])+2*sqr(Q[4][l])+2*sqr(Q[5][l])+2*sqr(Q[6][l]))
					-(0.75*A*sqr(SEQ)+0.25*B*SEQ*sqr(SEQ)+9*C*sqr(sqr(SEQ))/16.0)	
      ;
    }
  }
//   printf("\nthe free energy: %.20lf",free_energy);
  return free_energy;
  
}
//

//Computes all needed derivatives of the velocity field in a given point. The result is in units of RESP/TAU and not in the units of LB code (the difference is DT)
void izrOdvU2(int l, float *ux, float *uy, float *uz){
	int i,lxp,lxm,lyp,lym,lzp,lzm;
	
	float fakX=.5f, fakY=.5f, fakZ=.5f;
	
	lxp=l+1; lxm=l-1;
	lyp=l+I; lym=l-I;
	lzp=l+I*J; lzm=l-I*J;
	
	if(!(LMARK[lxp]&LMARK1)){ lxp=l; fakX=1.f;}	//Forward difference is used because due to TAUF>>DT the approximation of U=0 at the surface is ot fully justified.
	else if(!(LMARK[lxm]&LMARK1)){ lxm=l; fakX=1.f;}
	if(!(LMARK[lyp]&LMARK1)){ lyp=l; fakY=1.f;}
	else if(!(LMARK[lym]&LMARK1)){ lym=l; fakY=1.f;}
	if(!(LMARK[lzp]&LMARK1)){ lzp=l; fakZ=1.f;}
	else if(!(LMARK[lzm]&LMARK1)){ lzm=l; fakZ=1.f;}
	
	for(i=1;i<=3;i++)				/*derivatives of velocity U*/
	{
		ux[i]=fakX*(U[i][lxp]-U[i][lxm])/DT;	/*e.g. Ux[i] is derivative with respect to x of i-th component of U*/
		uy[i]=fakY*(U[i][lyp]-U[i][lym])/DT;
		uz[i]=fakZ*(U[i][lzp]-U[i][lzm])/DT;
	};
    
	
}

int ijk_to_l(int i, int j, int k){
    return i+j*I+k*I*J;
}

void interpoliraj_U(int i, int j, int k, float is, float jf, float kf, float* u){
    for(int m=1;m<=3;m++){
        u[m]=U[m][ijk_to_l(i,j,k)]*(1-is)*(1-jf)*(1-kf)+
        U[m][ijk_to_l(i+1,j,k)]*(is)*(1-jf)*(1-kf)+
        U[m][ijk_to_l(i,j+1,k)]*(1-is)*(jf)*(1-kf)+
        U[m][ijk_to_l(i+1,j+1,k)]*(is)*(jf)*(1-kf)+
        U[m][ijk_to_l(i,j,k+1)]*(1-is)*(1-jf)*(kf)+
        U[m][ijk_to_l(i+1,j,k+1)]*(is)*(1-jf)*(kf)+
        U[m][ijk_to_l(i,j+1,k+1)]*(1-is)*(jf)*(kf)+
        U[m][ijk_to_l(i+1,j+1,k+1)]*(is)*(jf)*(kf);
    }
}

//Computes all needed derivatives of the velocity field in a given point. The result is in units of RESP/TAU and not in the units of LB code (the difference is DT)
void izrOdvU2smeri(float* pos, float* n, float *grad){
    const float korak1=1.1;
    const float korak2=2.1;
    
    float pos1[4];
    float pos2[4];
    for(int i=1;i<=3;i++){
        pos1[i]=pos[i]+n[i]*korak1;
        pos2[i]=pos[i]+n[i]*korak2;
    }

    int i1,j1,k1;//indeks točke
    float if1,jf1,kf1;//ostanki med 0 in 1
    int i2,j2,k2;//indeks točke + normala*korak
    float if2,jf2,kf2;
    
    i1=(int)pos1[1];
    j1=(int)pos1[2];
    k1=(int)pos1[3];
    
    if1=pos1[1]-i1;
    jf1=pos1[2]-j1;
    kf1=pos1[3]-k1;
    
    i2=(int)pos2[1];
    j2=(int)pos2[2];
    k2=(int)pos2[3];
    
    if2=pos2[1]-i2;
    jf2=pos2[2]-j2;
    kf2=pos2[3]-k2;
    
    float u1[4];
    float u2[4];
    interpoliraj_U(i1,j1,k1,if1,jf1,kf1,u1);
    interpoliraj_U(i2,j2,k2,if2,jf2,kf2,u2);
    for(int i=1;i<=3;i++){
        grad[i]=(u2[i]-u1[i])/(korak2-korak1)/DT;
    }
	
}


//Fills in the local Q-tensor from the global matrix
void fillQl2(int l, float* ql){
 	ql[1]=Q[1][l];
	ql[2]=Q[2][l];
	ql[3]=Q[3][l];
	ql[4]=Q[4][l];
	ql[5]=Q[5][l];
	ql[6]=Q[6][l];
}

void fillQlm2(int l, float (*qlm)[4]){
	qlm[1][1]=Q[1][l];
	qlm[1][2]=Q[4][l];
	qlm[1][3]=Q[5][l];
	qlm[2][1]=Q[4][l];
	qlm[2][2]=Q[2][l];
	qlm[2][3]=Q[6][l];
	qlm[3][1]=Q[5][l];
	qlm[3][2]=Q[6][l];
	qlm[3][3]=Q[3][l];
}

//Computes the molecular field  -- U1 contribution
void calcU1(int l,float *u1, float* dxx, float* dyy, float* dzz, float* dx, float* dy, float* dz, float* ql){
  float	tr3,konst=fsqr(ql[1])+fsqr(ql[2])+fsqr(ql[3])+2*(fsqr(ql[4])+fsqr(ql[5])+fsqr(ql[6]));

  u1[4]=dxx[4]+dyy[4]+dzz[4]-2*C*ql[4]*fsqr(ql[4])-B*ql[5]*ql[6]-ql[4]*(A+B*ql[1]+C*fsqr(ql[1])+C*fsqr(ql[2])+B*ql[2]+C*fsqr(ql[3])+2*C*fsqr(ql[5])+2*C*fsqr(ql[6]));
  u1[5]=dxx[5]+dyy[5]+dzz[5]-2*C*ql[5]*fsqr(ql[5])-B*ql[4]*ql[6]-ql[5]*(A+B*ql[1]+C*fsqr(ql[1])+C*fsqr(ql[2])+B*ql[3]+C*fsqr(ql[3])+2*C*fsqr(ql[4])+2*C*fsqr(ql[6]));
  u1[6]=dxx[6]+dyy[6]+dzz[6]-2*C*ql[6]*fsqr(ql[6])-B*ql[4]*ql[5]-ql[6]*(A+B*ql[2]+C*fsqr(ql[1])+C*fsqr(ql[2])+B*ql[3]+C*fsqr(ql[3])+2*C*fsqr(ql[4])+2*C*fsqr(ql[5]));
  
  u1[1]=dxx[1]+dyy[1]+dzz[1]-A*ql[1]-B*(fsqr(ql[1])+fsqr(ql[4])+fsqr(ql[5]))-C*ql[1]*konst;
  u1[2]=dxx[2]+dyy[2]+dzz[2]-A*ql[2]-B*(fsqr(ql[2])+fsqr(ql[4])+fsqr(ql[6]))-C*ql[2]*konst;
  u1[3]=dxx[3]+dyy[3]+dzz[3]-A*ql[3]-B*(fsqr(ql[3])+fsqr(ql[5])+fsqr(ql[6]))-C*ql[3]*konst;
  
		tr3=(u1[1]+u1[2]+u1[3])/3.f;	//condition TrQ=0
		u1[1]-=tr3;
		u1[2]-=tr3;
		u1[3]-=tr3;


		H[1][l]=u1[1];			//store molecular field which will be needed later for compuing of symmetric and antisymmetric stress tensor
		H[2][l]=u1[2];
		H[3][l]=u1[3];
		H[4][l]=u1[4];
		H[5][l]=u1[5];
		H[6][l]=u1[6];
}



//Computes U2 contribution to the Q-tensor dynamics -- S_ij
void calcU2(float *u2, float *ux, float *uy, float *uz, float (*qlm)[4])
{

  
	float tr;
	float D[4][4], O[4][4];

	D[1][1]=ux[1];			//calculate matrix Dij =(Du_i/Dx_j+Du_j/Dx_i)/2  locally 
	D[1][2]=0.5f*(uy[1]+ux[2]);
	D[1][3]=0.5f*(uz[1]+ux[3]);
	D[2][1]=D[1][2];
	D[2][2]=uy[2];
	D[2][3]=0.5f*(uz[2]+uy[3]);
	D[3][1]=D[1][3];
	D[3][2]=D[2][3];
	D[3][3]=uz[3];

	O[1][1]=0.f;			//calculate matrix Omega_ij =(Du_i/Dx_j-Du_j/Dx_i)/2  locally
	O[1][2]=0.5f*(uy[1]-ux[2]);
	O[1][3]=0.5f*(uz[1]-ux[3]);
	O[2][1]=-O[1][2];
	O[2][2]=0.f;
	O[2][3]=0.5f*(uz[2]-uy[3]);
	O[3][1]=-O[1][3];
	O[3][2]=-O[2][3];
	O[3][3]=0.f;

	tr=	qlm[1][1]*ux[1]+qlm[1][2]*ux[2]+qlm[1][3]*ux[3]+
		qlm[2][1]*uy[1]+qlm[2][2]*uy[2]+qlm[2][3]*uy[3]+
		qlm[3][1]*uz[1]+qlm[3][2]*uz[2]+qlm[3][3]*uz[3];

	float D_qlm[4][4];	AMatrixB(D_qlm,D,qlm);
	float qlm_D[4][4];	AMatrixB(qlm_D,qlm,D);
	float O_qlm[4][4];	AMatrixB(O_qlm,O,qlm);
	float qlm_O[4][4]; 	AMatrixB(qlm_O,qlm,O);


	u2[1]= XI*(D_qlm[1][1]+qlm_D[1][1]+2.f/3.f*D[1][1])+O_qlm[1][1]-qlm_O[1][1]-2.f*XI*(qlm[1][1]+1.f/3.f)*tr;
	u2[2]= XI*(D_qlm[2][2]+qlm_D[2][2]+2.f/3.f*D[2][2])+O_qlm[2][2]-qlm_O[2][2]-2.f*XI*(qlm[2][2]+1.f/3.f)*tr;
	u2[3]= XI*(D_qlm[3][3]+qlm_D[3][3]+2.f/3.f*D[3][3])+O_qlm[3][3]-qlm_O[3][3]-2.f*XI*(qlm[3][3]+1.f/3.f)*tr;
	u2[4]= XI*(D_qlm[1][2]+qlm_D[1][2]+2.f/3.f*D[1][2])+O_qlm[1][2]-qlm_O[1][2]-2.f*XI*(qlm[1][2])*tr;
	u2[5]= XI*(D_qlm[1][3]+qlm_D[1][3]+2.f/3.f*D[1][3])+O_qlm[1][3]-qlm_O[1][3]-2.f*XI*(qlm[1][3])*tr;
	u2[6]= XI*(D_qlm[2][3]+qlm_D[2][3]+2.f/3.f*D[2][3])+O_qlm[2][3]-qlm_O[2][3]-2.f*XI*(qlm[2][3])*tr;
	
}


//Computes U3 contribution to Q-tensor dynamics -- advection term (v x nabla)Q
void calcU3(float *u3, float* dx, float* dy, float* dz, float* ul)
{
	u3[1]=(-ul[1]*dx[1]-ul[2]*dy[1]-ul[3]*dz[1])/DT;
	u3[2]=(-ul[1]*dx[2]-ul[2]*dy[2]-ul[3]*dz[2])/DT;
	u3[3]=(-ul[1]*dx[3]-ul[2]*dy[3]-ul[3]*dz[3])/DT;
	u3[4]=(-ul[1]*dx[4]-ul[2]*dy[4]-ul[3]*dz[4])/DT;
	u3[5]=(-ul[1]*dx[5]-ul[2]*dy[5]-ul[3]*dz[5])/DT;
	u3[6]=(-ul[1]*dx[6]-ul[2]*dy[6]-ul[3]*dz[6])/DT;
}


void izrCasKorQ(){

  
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500)
  for(int l=0;l<NMAX;l++){
    if(LMARK[l]==LMARK1){
      float Dxx2[7],Dyy2[7],Dzz2[7],Dx2[7],Dy2[7],Dz2[7],Ux2[4],Uy2[4],Uz2[4]; //Vectors in which derivatives are stored
      float Ql2[7];
      float Ul2[5];
      float Qlm2[4][4];
      float u1[7], u2[7], u3[7];
      fillQl2(l,Ql2);	//Fill the values of Q and U in local matrices
      fillQlm2(l,Qlm2);
      fillUl2(l, Ul2);
      izrOdvQ2(l,Dxx2,Dyy2,Dzz2,Dx2,Dy2,Dz2);	//Computes the derivatives of Q and U
      izrOdvU2(l,Ux2,Uy2,Uz2);
      calcU1(l,u1,Dxx2,Dyy2,Dzz2,Dx2,Dy2,Dz2,Ql2);			//calculate u1 contribution -- molecular field H_ij
      calcU2(u2, Ux2, Uy2, Uz2, Qlm2);					//calculate u1 contribution -- S_ij
 /*     float Sij=calcU2(u2, Ux2, Uy2, Uz2, Qlm2);
      printf("Sij = %f",Sij);
 */     
      calcU3(u3, Dx2, Dy2, Dz2, Ul2);					//calculate u1 contribution -- advection
      
      
      for(int m=1; m<7; m++) {Ql2[m]+=  DT/STCASKORQ*(u1[m]+u2[m]+u3[m]);}	//Time step in Q
      float tr3=(Ql2[1]+Ql2[2]+Ql2[3])/3.f;	//Make the trace 0
      Ql2[1]-=tr3; Ql2[2]-=tr3; Ql2[3]-=tr3; 
      for(int m=1; m<7; m++) QNEW[m][l]=Ql2[m];	//Write to global matrix
    }
    else if(LMARK[l]==LMARKPOV){	//Homeotropic anchoring
      for(int m=1; m<7; m++) {QNEW[m][l]= Q[m][l];}
      continue;	//Infinite anchoring
      float Dx2[7],Dy2[7],Dz2[7]; //Vectors, where the derivatives are stored
      float n1,n2,n3,qnic[7];
      float seq=SEQ;

      izrOdvQ2POV(l,Dx2,Dy2,Dz2);
      
      
      n1=QNIC[4][l];	//Surface normal
      n2=QNIC[5][l];
      n3=QNIC[6][l];
      
      
            
//       n1=QNIC[1][l];	//Surface normal
//       n2=QNIC[2][l];
//       n3=QNIC[3][l];
      
      //Preferred Q-tensor at the surface
      float dirX, dirY, dirZ;
      dirX=QNIC[1][l];
      dirY=QNIC[2][l];
      dirZ=QNIC[3][l];
      qnic[1]=0.5f*seq*(3*dirX*dirX-1);
      qnic[2]=0.5f*seq*(3*dirY*dirY-1);
      qnic[3]=0.5f*seq*(3*dirZ*dirZ-1);
      qnic[4]=1.5f*seq*(dirX*dirY);
      qnic[5]=1.5f*seq*(dirX*dirZ);
      qnic[6]=1.5f*seq*(dirY*dirZ);
      
      
      for(int m=1; m<7; m++) {QNEW[m][l]= Q[m][l] +  DT/STCASKORQ*(/*2.f**/(n1*Dx2[m]+n2*Dy2[m]+n3*Dz2[m])-WHOM*(Q[m][l]-qnic[m]) ); }	//Time step at the surface
    
      float tr3=(QNEW[1][l]+QNEW[2][l]+QNEW[3][l])/3.f;		//Make trace Q zero
      QNEW[1][l] -= tr3; QNEW[2][l] -= tr3; QNEW[3][l] -= tr3;
    }
//     else if(LMARK[l]==LMARKPOV){	//Planar degenerate anchoring
//       float Dx2[7],Dy2[7],Dz2[7];
//       float n1,n2,n3,qnic[7];
// 
//       izrOdvQ2POV(l,Dx2,Dy2,Dz2);
//       
//       
//       n1=QNIC[4][l];	//Surface normal
//       n2=QNIC[5][l];
//       n3=QNIC[6][l];
//       
//       
//       
//       
//       float q1=Q[1][l], q2=Q[2][l], q3=Q[3][l], q4=Q[4][l], q5=Q[5][l], q6=Q[6][l]; //local Q
//       float sq=sqrtf( 2.f/3.f * (fsqr(q1)+fsqr(q2)+fsqr(q3)+2*fsqr(q4)+2*fsqr(q5)+2*fsqr(q6)) ); //local order parameter S
//       float n11=n1*n1, n22=n2*n2, n33=n3*n3, n12=n1*n2, n13=n1*n3, n23=n2*n3;
//       float nqn=q1*n11+q2*n22+q3*n33+2*(q4*n12+q5*n13+q6*n23);
//       float QPOV[7];
//         QPOV[1]=(sq-2*nqn)*n11   +4*(n11*q1+n12*q4+n13*q5);
//         QPOV[2]=(sq-2*nqn)*n22   +4*(n12*q4+n22*q2+n23*q6);
//         QPOV[3]=(sq-2*nqn)*n33   +4*(n13*q5+n23*q6+n33*q3);
//         QPOV[4]=(sq-2*nqn)*n12 +2*(n11*q4+n12*q2+n13*q6+n12*q1+n22*q4+n23*q5);
//         QPOV[5]=(sq-2*nqn)*n13 +2*(n11*q5+n12*q6+n13*q3+n13*q1+n23*q4+n33*q5);
//         QPOV[6]=(sq-2*nqn)*n23 +2*(n12*q5+n22*q6+n23*q3+n13*q4+n23*q2+n33*q6);
//       
//       
//       for(int m=1; m<7; m++) {QNEW[m][l]=Q[m][l]+  DT/STCASKORQ*(2.f*(n1*Dx2[m]+n2*Dy2[m]+n3*Dz2[m])-WHOM*QPOV[m] ); }	//Time step at the surface
//     
//       float tr3=(QNEW[1][l]+QNEW[2][l]+QNEW[3][l])/3.f;		//Make trace Q zero
//       QNEW[1][l] -= tr3; QNEW[2][l] -= tr3; QNEW[3][l] -= tr3;
//     }
//     
    
    
  }
  calcQNEW2Q();		//Set the periodic boundary conditions

  
  
  
}

//Set the periodic boundary conditions
void calcQNEW2Q(){
  #pragma omp parallel for num_threads(STPROC) schedule(dynamic, 2500)
  for(int l=0; l<NMAX; l++){
   int lpbc=calcLpbc(l);
   /*if(lpbc!=l) */for(int m=1; m<7; m++) Q[m][l]=QNEW[m][lpbc];
 }
}

