
//Write the necessay data that can be later used for initialisation
void zapisDATA(char *ime)
{
	FILE *file;
	int l,m;
	float delovni;
	char delovni2;

	file=fopen(ime,"w");
    if(file==NULL){
        fprintf(stderr, "Failed opening file. w mode. file=%s\n", ime);
        exit(1);
    }
	for(l=0;l<NMAX;l++){
		for(m=0;m<ST_HITROSTI;m++)
		{
			delovni=F[m][l];
			fwrite(&delovni,sizeof(float),1,file);
		};
	}
	for(l=0;l<NMAX;l++){
		for(m=1;m<7;m++)
		{
			delovni=Q[m][l];
			fwrite(&delovni,sizeof(float),1,file);
		};
	}
	for(l=0;l<NMAX;l++){
		for(m=1;m<7;m++)
		{
			delovni=QNIC[m][l];
			fwrite(&delovni,sizeof(float),1,file);
		};
	}
	for(l=0;l<NMAX;l++){
		{
			delovni2=LMARK[l];
			fwrite(&delovni2,sizeof(char),1,file);
		};
	}
	fclose(file);
}


//Write the Q-tensor
void zapisQ(char *ime)
{
	FILE *file;
	int l,m;
	float delovni;

	file=fopen(ime,"w");
    if(file==NULL){
        fprintf(stderr, "Failed opening file. w mode. file=%s\n", ime);
         exit(1);
    }

	for(l=0;l<NMAX;l++){
		for(m=1;m<7;m++)
		{
			delovni=Q[m][l];
			fwrite(&delovni,sizeof(float),1,file);
		};
	}

	fclose(file);
}


//Reads the data file
void beriDATA(char *ime)
{
	FILE *file;
	int l,m;
	float delovni;
	char delovni2;
	int result;

	file=fopen(ime,"r");
    if(file==NULL){
        fprintf(stderr, "Failed opening file. r mode. file=%s\n", ime);
        exit(1);
    }
    
	for(l=0;l<NMAX;l++){
		for(m=0;m<ST_HITROSTI;m++)
		{
		  result=fread(&delovni,sizeof(float),1,file);
		  if (result != 1) {fputs ("Error reading data!\n",stderr); exit (2);}
		  F[m][l]=delovni;
		};
	}
	for(l=0;l<NMAX;l++){
		for(m=1;m<7;m++)
		{
		  result=fread(&delovni,sizeof(float),1,file);
		  if (result != 1) {fputs ("Error reading data!\n",stderr); exit (2);}
		  Q[m][l]=delovni;
		};
	}
	for(l=0;l<NMAX;l++){
		for(m=1;m<7;m++)
		{
		  result=fread(&delovni,sizeof(float),1,file);
		  if (result != 1) {fputs ("Error reading data!\n",stderr); exit (2);}
		  QNIC[m][l]=delovni;
		};
	}
	for(l=0;l<NMAX;l++){
		{
		  result=fread(&delovni2,sizeof(char),1,file);
		  if (result != 1) {fputs ("Error reading data!\n",stderr); exit (2);}
		  LMARK[l]=delovni2;
		}
	}
	fclose(file);
}


//Writes the velocity profile along the chosen direction
void za_profilU(char *ime, int i, int j){
  FILE *file;
  file=fopen(ime, "w");
  if(file==NULL){
    fprintf(stderr, "Failed opening file. w mode. file=%s\n", ime);
     exit(1);
  }

  
  i=I/2;
  j=J/2;
  int k,l;
  float dir[4];
  
  //for(k=0;k<J;k++){
   //l=i*J*I+j+k*I;
  for(k=0;k<K;k++){
   l=i+j*I+k*I*J;
   calcQ2dirL(l,dir);
   if((LMARK[l]&LMARKKOL)) fprintf(file,"%d 0 0 0 0\n", k);
   else fprintf(file,"%d %.5e %.5e %.5e %.5e\n", k,dir[0], dir[1], dir[2], dir[3]);
   //if(!(LMARK[l]&LMARK1)) fprintf(file,"%d 0 0 0 0\n", k);
   //else fprintf(file,"%d %.5e %.5e %.5e %.5e\n", k,U[1][l], U[2][l], U[3][l], U[4][l]);
  }
  fclose(file);
}


//Writes the velocity field (with Paraview header)
void zapisUraw(char *ime){
  // do it in binary
  int l;
  float tempU[3];
  FILE *file;

  file=fopen(ime,"w");
  if(file==NULL){
    fprintf(stderr, "Failed opening file. w mode. file=%s\n", ime);
     exit(1);
  }

  
  fprintf(file,"# vtk DataFile Version 3.0\nKnot\nBINARY\nDATASET STRUCTURED_POINTS\n");
  fprintf(file,"DIMENSIONS %d %d %d\n",I,J,K);
  fprintf(file,"ORIGIN 0 0 0\n");
  fprintf(file,"SPACING 1 1 1\n");
  fprintf(file,"POINT_DATA %d\n",I*J*K);
  fprintf(file,"VECTORS U float\n");

  for(l=0; l<NMAX; l++)
  {
    if(LMARK[l]!=LMARK1)
    { 
      tempU[0]=0; tempU[1]=0; tempU[2]=0;
    }
    else
    {
      // go to bigendian
      float temp0 = FloatSwap(U[1][l]); 
      tempU[0]=temp0;
      float temp1 = FloatSwap(U[2][l]);
      tempU[1]=temp1;
      float temp2 = FloatSwap(U[3][l]);
      tempU[2]=temp2;
    }
    fwrite(tempU,sizeof(float),3,file);
  };
  fclose(file);
}


// //Writes the density field (with Amira header)
// void zapisDENraw(char *ime){
//   
//   int l;//i,j,k; 
//   FILE *file;
//  
//   file=fopen(ime,"w");
//   if(file==NULL){
//     fprintf(stderr, "Failed opening file. w mode. file=%s\n", ime);
//      exit(1);
//   }
// 
//   fprintf(file,"# AmiraMesh BINARY-LITTLE-ENDIAN 2.1\n\n");
//   fprintf(file,"define Lattice %d %d %d\n\n",I,J,K);
//   fprintf(file,"Parameters {\n");
//   fprintf(file,"BoundingBox 0 %d 0 %d 0 %d\n",I-1,J-1,K-1);
//   fprintf(file,"CoordType \"uniform\"\n}\n\n");
//   fprintf(file,"Lattice { float[1] Data } @1\n\n");
//   fprintf(file,"# Data section follows \n@1\n");
// 
//   for(l=0;l<NMAX;l++){ 
//     float delovni;
//     /*if(LMARK[l]&LMARKRP){ delovni=DENSITYINIT;}
//     else*/ delovni=U[4][l];
//     fwrite(&delovni,sizeof(float),1,file);
//   }
//   fclose(file);
// }

//Writes the density field (with Paraview header)
void zapisDENraw(char *ime){
  
  int l;//i,j,k; 
  FILE *file;
  float tempDEN[1];
 
  file=fopen(ime,"w");
  if(file==NULL){
    fprintf(stderr, "Failed opening file. w mode. file=%s\n", ime);
     exit(1);
  }
    fprintf(file,"# vtk DataFile Version 3.0\nKnot\nBINARY\nDATASET STRUCTURED_POINTS\n");
    fprintf(file,"DIMENSIONS %d %d %d\n",I,J,K);
    fprintf(file,"ORIGIN 0 0 0\n");
    fprintf(file,"SPACING 1 1 1\n");
    fprintf(file,"POINT_DATA %d\n",I*J*K);
    fprintf(file,"SCALARS density float\nLOOKUP_TABLE default\n");


  for(l=0;l<NMAX;l++){ 
    float delovni;
    /*if(LMARK[l]&LMARKRP){ delovni=DENSITYINIT;}
    else*/ 
    float temp4=FloatSwap(U[4][l]);
    tempDEN[0]=temp4;

    fwrite(tempDEN,sizeof(float),1,file);
  }
  fclose(file);
}



//Computes the local director field (in the point with index l) from the local Q-tensor
void calcQ2dirL(int l,float *dir)
{
	int i,max_ind;
      if(!(LMARK[l]&LMARKKOL)){
	float **del,d[4],e[4],max;

	del=matrix(1,3,1,3);

	//Diagonalisation
	del[1][1]=Q[1][l]; del[1][2]=Q[4][l]; del[1][3]=Q[5][l];
	del[2][1]=Q[4][l]; del[2][2]=Q[2][l]; del[2][3]=Q[6][l];
	del[3][1]=Q[5][l]; del[3][2]=Q[6][l]; del[3][3]=Q[3][l];
	tred2(del,3,d,e);  //Sintax: matrix to be diagonalised (will be modified in the process); matrix dimension; main diagonal vector; upper diagonal vector
	tqli(d,e,3,del);   //Sintax: main diagonal (where eigenvalues are later stored); upper+bottom diagonal; dimension; output matrix from tred2

	//Find the largest eigenvalue and the director
	max=d[1]; max_ind=1;
	for(i=2;i<=3;i++){if(d[i]>max){max=d[i];max_ind=i;};};
	dir[0]=del[1][max_ind];dir[1]=del[2][max_ind];dir[2]=del[3][max_ind];
	dir[3]=max;
	//printf("%f %f %f     ", dir[1], dir[2], dir[3]);
	free_matrix(del,1,3,1,3);
      }
      else{ for(i=0;i<3;i++) dir[i]=0.f; dir[3]=1;}
}


//Writes the director field (with Amira header), computed from the Q-tensor
void zapisQ2DIRraw(char *ime)
{
	int l;
	float dir[4];
	FILE *file;

// 	file=fopen(ime,"w");
// 	fprintf(file,"# AmiraMesh BINARY-LITTLE-ENDIAN 2.1\n\n");
// 	fprintf(file,"define Lattice %d %d %d\n\n",I,J,K);
// 	fprintf(file,"Parameters {\n");
// 	fprintf(file,"BoundingBox 0 %d 0 %d 0 %d\n",I-1,J-1,K-1);
// 	fprintf(file,"CoordType \"uniform\"\n}\n\n");
// 	fprintf(file,"Lattice { float[3] Data } @1\n\n");
// 	fprintf(file,"# Data section follows \n@1\n");

    
    file=fopen(ime,"w");
    if(file==NULL){
        fprintf(stderr, "Failed opening file. w mode. file=%s\n", ime);
         exit(1);
    }

    fprintf(file,"# vtk DataFile Version 3.0\nKnot\nBINARY\nDATASET STRUCTURED_POINTS\n");
    fprintf(file,"DIMENSIONS %d %d %d\n",I,J,K);
    fprintf(file,"ORIGIN 0 0 0\n");
    fprintf(file,"SPACING 1 1 1\n");
    fprintf(file,"POINT_DATA %d\n",I*J*K);
    fprintf(file,"VECTORS n float\n");

	for(l=0; l<NMAX; l++){
	  calcQ2dirL(l,dir);														//calculate director locally
	  //if(LMARK[l]&LMARK1){dir[0]=0; dir[1]=0; dir[2]=0;}
	  //else{dir[0]=QNIC[1][l]; dir[1]=QNIC[2][l]; dir[2]=QNIC[3][l];}
     
      
      // go to bigendian
      float dir0 = FloatSwap(dir[0]); 
      dir[0]=dir0;
      float dir1 = FloatSwap(dir[1]);
      dir[1]=dir1;
      float dir2 = FloatSwap(dir[2]);
      dir[2]=dir2;
      
      fwrite(dir,sizeof(float),3,file);
        
    };
    fclose(file);
        
    
}


//Writes the order parameter field (with Amira header), computed from the Q-tensor
void zapisQ2OPraw(char *ime)
{
	/*int l;
	float dir[4];
	float delovni;
	FILE *file;

	file=fopen(ime,"w");
	fprintf(file,"# AmiraMesh BINARY-LITTLE-ENDIAN 2.1\n\n");
	fprintf(file,"define Lattice %d %d %d\n\n",I,J,K);
	fprintf(file,"Parameters {\n");
	fprintf(file,"BoundingBox 0 %d 0 %d 0 %d\n",I-1,J-1,K-1);
	fprintf(file,"CoordType \"uniform\"\n}\n\n");
	fprintf(file,"Lattice { float[1] Data } @1\n\n");
	fprintf(file,"# Data section follows \n@1\n");

	for(l=0; l<NMAX; l++){
	  calcQ2dirL(l,dir);														//calculate director locally
	  delovni=dir[3];
	  fwrite(&delovni,sizeof(float),1,file);
	};
	fclose(file);*/

    
    
    //Writes the order parameter field (with Paraview header), computed from the Q-tensor    
    // do it in binary
    int l;
    float dir[4];
    float delovni;
    FILE *file;
    
    float Sk=0.4;
    float S;
    float DFV=0;

    file=fopen(ime,"w");
    if(file==NULL){
        fprintf(stderr, "Failed opening file. w mode. file=%s\n", ime);
        exit(1);
    }

    fprintf(file,"# vtk DataFile Version 3.0\nKnot\nBINARY\nDATASET STRUCTURED_POINTS\n");
    fprintf(file,"DIMENSIONS %d %d %d\n",I,J,K);
    fprintf(file,"ORIGIN 0 0 0\n");
    fprintf(file,"SPACING 1 1 1\n");
    fprintf(file,"POINT_DATA %d\n",I*J*K);
    fprintf(file,"SCALARS order float\nLOOKUP_TABLE default\n");
    
//     FILE *defect_volume;
//     defect_volume=fopen("./data/defect_volume.txt","a");
//     fprintf(defect_volume, "DFV\n");

    int count=0;
    for(l=0; l<NMAX; l++){
        calcQ2dirL(l,dir);														//calculate director locally    
        delovni = FloatSwap(dir[3]); // go to bigendian
        fwrite(&delovni,sizeof(float),1,file);
        
        S=dir[3];
        if (LMARK[l]==LMARK1) {
            count++;
            if (S < Sk) DFV+=1;
        }

        
         
        
    };
    DFV=DFV/count;
//     fprintf(defect_volume, "%f\n", DFV);
//     fclose(defect_volume);
//     printf("defect volume fraction: %f\n", DFV);
    
    fclose(file);
//     fclose(defect_volume);
    

}


//Sum of points where S is smaller than Sk=0.4

void zapisDVF(char *ime){
    int l;
    float dir[4];
    float delovni;
    
    float Sk=0.4;
    float S;
    float DVF=0;
    
    FILE *defect_volume;
    defect_volume=fopen("./data/defect_volume.txt","a");
    if(defect_volume==NULL){
        fprintf(stderr, "Failed opening file. a mode. file=%s\n", "./data/defect_volume.txt");
        exit(1);
    }



    int count=0;
    for(l=0; l<NMAX; l++){
        calcQ2dirL(l,dir);														//calculate director locally    
        delovni = FloatSwap(dir[3]); // go to bigendian
        S=dir[3];
        if (LMARK[l]==LMARK1) {
            count++;
            if (S < Sk) DVF+=1;
        }
        
    };
    
    DVF=DVF/count;
    fprintf(defect_volume, "%f\n", DVF);
//     fclose(defect_volume);
    printf("defect volume fraction: %f\n", DVF);
    fprintf(stderr,"defect volume fraction: %f\n", DVF);

    fclose(defect_volume);
    
}

//----------------------------------------Dipol distance from coloid------------------------------------------------------------------------

//Points where S is smaller than Sk=0.4 and theirs distance from coloid's center (0,0,0)
void zapisDistance(){
    float dir[4];
    float delovni;
    
    FILE *dipol_distance;
    dipol_distance=fopen("./data/dipol_distance.txt","a");
    if(dipol_distance==NULL){
        fprintf(stderr, "Failed opening file. a mode. file=%s\n", "./data/dipol_distance.txt");
        exit(1);
    }

        
    float Sk=0.4;
    float S;
    float DVF=0;
    float distance=0;
    float second_distance=0;    
    int count=0;
    double center[3]={0,0,0};
//     fprintf(stderr, "sem v funkciji dipol distance\n");
     
    
    for(int l=0; l<NMAX; l++){
        calcQ2dirL(l,dir);														//calculate director locally    
        delovni = FloatSwap(dir[3]); // go to bigendian
//         printf("for zanka v dipol distance\n");
        S=dir[3];

//         fprintf(stderr, "LMARK[l] = %d; ",LMARK[l]);
//         
        if(LMARK[l]==LMARK1){
//             fprintf(stderr, "S = %f; ",S);
            if (S < Sk){
                count++;
                float x,y,z,r,rr; 
                            
                x=(float)(i_vr(l))-(float)(I-1)/2+0.001;
                y=(float)(j_vr(l))-(float)(J-1)/2+0.001;
                z=(float)(k_vr(l))-(float)(K-1)/2+0.001;
                
                rr = (x - center[0]) * (x - center[0]) + (y - center[1]) * (y - center[1]) + (z - center[2]) * (z - center[2]);
                r = sqrt((x - center[0]) * (x - center[0]) + (y - center[1]) * (y - center[1]) + (z - center[2]) * (z - center[2]));
                distance = distance + r;
//                 fprintf(stderr, "distance = %f; ",distance);
//                 fprintf(stderr, "count = %d\n",count);
                second_distance = second_distance + rr;
                
            
            }
            
        };
        


    };
    
//     fprintf(stderr, "konec funkcije\n");
  
    fprintf(stderr, "%f,%f,%f,%f\n",distance, distance/count, second_distance, second_distance/count);
    fprintf(dipol_distance, "%f,%f,%f,%f\n",distance, distance/count, second_distance, second_distance/count);
    fclose(dipol_distance);
    
}


//-----------------------------------------------DIMERI---------------------------------------------------------------------------------------
// //Reads the data file for active droplet
// void beriDROPLETDATA(char *ime)
// {
// 	FILE *file;
// 	int l,m;
// 	float delovni;
// 	char delovni2;
// 	int result;
// 
// 	file=fopen(ime,"r");
//     if(file==NULL){
//         fprintf(stderr, "Failed opening file. r mode. file=%s\n", ime);
//          exit(1);
//     }
// 
//     fprintf(stderr,"zacetek\n");
//     
//     int sizes[3]; 
//     int q0;
//     int count=0;
//     float normal[3];
//     fread(sizes,sizeof(int),3,file);
//     fprintf(stderr,"beremo velikost %dx%dx%d, Nmax=%d\n",sizes[0],sizes[1],sizes[2],NMAX);
//     
//       
//     
// 	for(l=0;l<NMAX;l++){
// 		for(m=0;m<6;m++)
// 		{
// 		  result=fread(&delovni,sizeof(float),1,file);
// 		  if (result != 1) {fputs ("Error reading data!\n",stderr); exit (2);}
// 		  Q[m+1][l]=delovni;
//           QNEW[m+1][l]=delovni;
// 		};
//         
//         UNIC[1][l]=0.f;		//surface velocity
//         UNIC[2][l]=0.f;
//         UNIC[3][l]=0.f;
//         
//         
//         //change LMARK      
//         result=fread(&delovni2,sizeof(char),1,file);
//         
//         LMARK[l]=delovni2;
//         if (delovni2==1) {LMARK[l]=32;}
//         else if (delovni2==16 || delovni2==32 || delovni2==64 || delovni2==96) {LMARK[l]=8;}
// /*        delovni2=LMARK[l];
//         fwrite(&delovni2,sizeof(char),1,file); */        
//         
//         
// //         if(delovni2)fprintf(stderr,"%d %d\n",l,delovni2);
//         //if(l%3==0)        fprintf(stderr,"%f %f %f %f %f %f\n",Q[1][l],Q[2][l],Q[3][l],Q[4][l],Q[5][l],Q[6][l]);
// 	}
// 	    for(l=0;l<NMAX;l++){
//         int lxp,lxm,lyp,lym,lzp,lzm;
//         if(i_vr(l)==0) {lxp=l+1; lxm=l+I-1;}		//periodicnost po x smeri
//         else if(i_vr(l)==I-1) {lxp=l-(I-1); lxm=l-1;}
//         else {lxp=l+1; lxm=l-1;};
// 
//         if(j_vr(l)==0) {lyp=l+I; lym=l+(J-1)*I;}	//periodicnost po y smeri
//         else if(j_vr(l)==J-1) {lyp=l-(J-1)*I; lym=l-I;}
//         else {lyp=l+I; lym=l-I;};
// 
//         if(k_vr(l)==0) {lzp=l+I*J; lzm=l+(K-1)*I*J;}	//periodicnost po z smeri
//         else if(k_vr(l)==K-1) {lzp=l-(K-1)*I*J; lzm=l-I*J;}
//         else {lzp=l+I*J; lzm=l-I*J;}; 
//         
//         
//         if(LMARK[lxp]&(LMARKPOV|LMARKKOL) && LMARK[lxm]&(LMARKPOV|LMARKKOL) && LMARK[lyp]&(LMARKPOV|LMARKKOL) && LMARK[lym]&(LMARKPOV|LMARKKOL) && LMARK[lzp]&(LMARKPOV|LMARKKOL) && LMARK[lzm]&(LMARKPOV|LMARKKOL)){ LMARK[l]=(LMARKKOL|LMARK0);}
//   }
// 
//   for(l=0;l<NMAX;l++){
//     if(i_vr(l)==0 || i_vr(l)==I-1 || j_vr(l)==0 || j_vr(l)==J-1 || k_vr(l)==0 || k_vr(l)==K-1) LMARK[l]=(LMARK[l]|LMARKRP);														
//     else if(LMARK[l]&LMARKKOL) for(int m=1; m<ST_HITROSTI; m++) if(LMARK[calcLBlnew(l, m)]&(LMARK1|LMARKPOV)) LMARK[l]=LMARKKOL;
//   }
//   
// 	
// 	result=fread(&q0, sizeof(int),1,file);
//     fprintf(stderr,"result = %d\n",result);
//     
//     fprintf(stderr,"q0 = %d\n",q0);
//     for(l=0;l<NMAX;l++){
//         if(LMARK[l]==8){
//             fread(normal, sizeof(float), 3, file);
//             count++;
//             QNIC[1][l]= normal[0];
//             QNIC[2][l]= normal[1];
//             QNIC[3][l]= normal[2];
//             /*
//             
//             QNIC[1][l]=0.5f*SEQ*(3*normal[0]*normal[0]-1);
//             QNIC[2][l]=0.5f*SEQ*(3*normal[1]*normal[1]-1);
//             QNIC[3][l]=0.5f*SEQ*(3*normal[2]*normal[2]-1);
//             QNIC[4][l]=1.5f*SEQ*(normal[0]*normal[1]);
//             QNIC[5][l]=1.5f*SEQ*(normal[0]*normal[2]);
//             QNIC[6][l]=1.5f*SEQ*(normal[1]*normal[2]);
//             */
//         }
//     }
//     
//     fprintf(stderr,"count = %d\n",count);
// 	
//     //fprintf(stderr,"konec\n");
// 	fclose(file);
// }  



