#ifndef DIF_EQ_SYSTEM_H
#define DIF_EQ_SYSTEM_H

void propagate_trajectories_block(double* variables, double nu, double chi, double xi_rot, double xi_alpha,
  double dt, int num_steps);
void propagate_trajectories(double* variables0, double nu, double chi, double xi_rot, double xi_alpha,
                            double t_span, double dt, int num_save,
                            double* results, double* timepoints, int* nfev);
void velocity_field(double* defect_config, int n, double* lattice_thetas, double* lattice_phis,
  double nu, double rho, double* velocities);
void x_to_z_transf(int n, double* vectors);

void velocity_field_drag(double* defect_config, int n, double* lattice_thetas, double* lattice_phis,
  double* lattice_basis, double* lattice_grad_theta, double* lattice_grad_phi, 
  double nu, double mu, double rho, double* velocities, const int num_cores);

void sph_to_cart(double theta, double phi, double* cartesian);
void lattice_base(int n, double* thetas, double* phis, double* basis);

void velocity_field_fast(double* defect_config, int n, double* lattice_thetas, double* lattice_phis,
  double* lattice_basis, double nu, double rho, double* velocities, const int num_cores);
void ephi(double phi, double* vector);
void etheta(double phi, double theta, double* vector);

void propagate_trajectories_step_drag(double* variables, double* grad_theta, double* grad_phi,
                                      double nu, double chi, double mu, double xi_rot, double xi_alpha,
                                      double dt);

#endif
